<script setup lang="ts">
import { ref, onMounted, watch } from 'vue'
import Chart from 'chart.js/auto'
import { useStockStore } from '@/stores/stock';

const stockStore = useStockStore()
const selectedDate = ref()
const selectedType = ref('จำนวนวัตถุดิบที่ใช้,รายเดือน')
const types = ['จำนวนวัตถุดิบคงเหลือ,รายเดือน', 'จำนวนวัตถุดิบคงเหลือ,รายปี', 'จำนวนวัตถุดิบที่ใช้,รายเดือน', 'จำนวนวัตถุดิบที่ใช้,รายปี']
const month = ref<number>(0)
const year = ref<number>(0)
const reportData = ref<any>([])
const materialNames: string[] = []
const amount: number[] = []
const colors: string[] = []
const graphName = ref<string>('ค่าเริ่มต้น')

onMounted(() => {
    assignGraph()
})
const config = {
    type: 'bar',
    data: {
        labels: materialNames,
        datasets: [
            {
                barPercentage: 0.5,
                barThickness: 5,
                maxBarThickness: 5,
                minBarLength: 3,
                label: graphName.value,
                data: amount,
                backgroundColor: colors,
                borderWidth: 0.5
            }
        ]
    },
    options: {
        indexAxis: 'y',
        responsive: true,
        maintainAspectRatio: false,
        scales: {
            y: {
                beginAtZero: true
            },
        }
    }
}

let myChart;

const assignGraph = () => {
    const ctx = document.getElementById('myChart')
    if (myChart) {
        myChart.destroy()
    }
    myChart = new Chart(ctx, config)
}


function generateRandomColor(): string {
    const r = Math.floor(Math.random() * 256)
    const g = Math.floor(Math.random() * 256)
    const b = Math.floor(Math.random() * 256)
    return `#${r.toString(16).padStart(2, '0')}${g.toString(16).padStart(2, '0')}${b.toString(16).padStart(2, '0')}`
}

async function GetMonthlyUsedAmout() {
    const currentMonth = await stockStore.GetStockDetailsSet(month.value, year.value)
    const lastMonth = await stockStore.GetStockDetailsMinusOne(month.value - 1, year.value)
    for (const current of currentMonth) {
        const exist = lastMonth.find((last: any) => last.M_NAME === current.M_NAME);
        if (exist) {
            console.log('1')
            materialNames.push(exist.M_NAME)
            amount.push(exist.SD_QOH - current.SD_QOH)
            colors.push(generateRandomColor())
            console.log("materialNames: ", materialNames)
            console.log("amount: ", amount)
        } else {
            console.log('2')
            materialNames.push(current.M_NAME)
            amount.push(current.SD_QOH)
            colors.push(generateRandomColor())
            console.log("materialNames: ", materialNames)
            console.log("amount: ", amount)
        }
    }
}
async function GetYearlyUsedAmout() {
    const currentMonth = await stockStore.GetStockDetailsSet(month.value, year.value)
    const lastMonth = await stockStore.GetStockDetailsMinusOne(month.value - 1, year.value)
    for (const current of currentMonth) {
        const exist = lastMonth.find((last: any) => last.M_NAME === current.M_NAME);
        if (exist) {
            materialNames.push(exist.M_NAME)
            amount.push(exist.SD_QOH - current.SD_QOH)
            colors.push(generateRandomColor())
        } else {
            materialNames.push(current.M_NAME)
            amount.push(current.SD_QOH)
            colors.push(generateRandomColor())
        }
    }
}

function updateGraph() {
    //assign ค่า SD_QOH กับ M_NAME
    // อัปเดตกราฟเมื่อมีการเลือกวันที่หรือประเภทของกราฟ
    console.log(selectedDate.value, selectedType.value)
    assignGraph()
}

function clearChartData() {
    materialNames.splice(0, materialNames.length);
    amount.splice(0, amount.length);
    colors.splice(0, colors.length);
}

watch([selectedDate, selectedType], async ([newDate, newType], [oldDate, oldType]) => {
    // ทำสิ่งที่ต้องการเมื่อ selectedDate หรือ selectedType เปลี่ยนแปลง
    if (newDate) {
        clearChartData()
        const date = new Date(newDate)
        const mm = date.getMonth() + 1 // เพิ่ม 1 เนื่องจาก getMonth() ส่งค่ากลับมาเริ่มจาก 0
        const yyyy = date.getFullYear()
        console.log('newDate: ', newDate)
        month.value = mm
        year.value = yyyy

    } else {
        return;
    }

    console.log('Selected date:', newDate)
    console.log('Selected type:', newType)
    if (selectedType.value == 'จำนวนวัตถุดิบคงเหลือ,รายเดือน') {
        reportData.value = await stockStore.GetStockDetailsByMonth(month.value, year.value)
        for (const obj of reportData.value) {
            const name = obj.M_NAME
            const value = obj.SD_QOH
            console.log('name:', name)
            console.log('value:', value)
            materialNames.push(name)
            amount.push(value)
            colors.push(generateRandomColor())
        }
        console.log("materialNames: ", materialNames)
        console.log("amount: ", amount)
        config.data.datasets[0].label = `กราฟแสดงจำนวนวัตถุดิบคงเหลือล่าสุดในเดือน ${month.value} ปี ${year.value}`
        assignGraph()
    } else if (selectedType.value == 'จำนวนวัตถุดิบคงเหลือ,รายปี') {
        reportData.value = await stockStore.GetStockDetailsByYear(year.value)
        for (const obj of reportData.value) {
            const name = obj.M_NAME
            const value = obj.SD_QOH
            console.log('name:', name)
            console.log('value:', value)
            materialNames.push(name)
            amount.push(value)
            colors.push(generateRandomColor())
        }
        console.log("materialNames: ", materialNames)
        console.log("amount: ", amount)
        config.data.datasets[0].label = `กราฟแสดงจำนวนวัตถุดิบคงเหลือล่าสุดในปี ${year.value}`
        assignGraph()
    } else if (selectedType.value == 'จำนวนวัตถุดิบที่ใช้,รายเดือน') {
        GetMonthlyUsedAmout()
        console.log("materialNames: ", materialNames)
        console.log("amount: ", amount)
        config.data.datasets[0].label = `กราฟแสดงจำนวนวัตถุดิบที่ใช้ระหว่างเดือนปัจจุบัน ${year.value} กับเดือนก่อนหน้า ${year.value - 1}`
        assignGraph()
    } else if (selectedType.value == 'จำนวนวัตถุดิบที่ใช้,รายปี') {
        //GetMonthlyUsedAmout()
        console.log("materialNames: ", materialNames)
        console.log("amount: ", amount)
        config.data.datasets[0].label = `กราฟแสดงจำนวนวัตถุดิบที่ใช้ระหว่างปีปัจจุบัน ${year.value} กับปีก่อนหน้า ${year.value - 1}`
        assignGraph()
    }
})
</script>

<template>
    <v-sheet>
        <div>
            <v-row>
                <v-col>
                    <v-text-field v-model="selectedDate" label="วันที่" placeholder="Enter date" clearable
                        variant="outlined" type="date" filled rounded density="compact"></v-text-field>
                </v-col>
                <v-col>
                    <v-select v-model="selectedType" :items="types" density="compact" label="รูปแบบของกราฟ"
                        variant="outlined" filled rounded></v-select>
                </v-col>
            </v-row>
            <v-row>
                <div style="height: 100%; width: 100%"><canvas id="myChart" style="width: 100%; height: 100%;"></canvas>
                </div>
            </v-row>
        </div>
    </v-sheet>
</template>
<style scoped></style>
